select
  an.numero,
   (case when (rep.cdtiporeproducao in (1,2)) then rep.data
  	when rep.cdtiporeproducao = 3 then (rep.data - 7) else null end) as data,
  extract(month from (case when (rep.cdtiporeproducao in (1,2)) then rep.data
  	when rep.cdtiporeproducao = 3 then (rep.data - 7) else null end)) as mes,
  extract(year from (case when (rep.cdtiporeproducao in (1,2)) then rep.data
  	when rep.cdtiporeproducao = 3 then (rep.data - 7) else null end)) as ano,
  (cast((select count(*) from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao in (1,2,3) and re.data < rep.data and re.data > coalesce(par.data, '1900-01-01')) as integer) + 1) as ordem_tentativa,
  (select grausangue from sp_calculagrausangue(an.cdanimal)) as "RAA_MATRIZ",
  tou.numero as reprodutor,  
  maeemb.numero as doadora,
  emb.numero as num_embriao,
  (case col.tipocoleta when 1 then 'FIV' when 2 then 'TE' else 'IA/COB' end) as tipocoleta,
  (case when (diag.diagnostico='P') then 'P' when (diag.cdtiporeproducao in (1,2,3)) then 'N' when (diag.diagnostico='N') then 'N' when (diag.cio in ('1','2')) then 'N' else 'A' end) as diagnostico,
  (case when (diag.diagnostico='P') then '1' when (diag.cdtiporeproducao in (1,2,3)) then '1' when (diag.diagnostico='N') then '1' when (diag.cio in ('1','2')) then '1' else '0' end) as contagem_para_concepcao_com_DG,
  (case when (diag.diagnostico='P') then '1' when (diag.cdtiporeproducao in (1,2,3)) then '0' when (diag.diagnostico='N') then '0' when (diag.cio in ('1','2')) then '0' else '0' end) as contagem_para_concepcao_positiva,
  (case when (diag.diagnostico = 'P') then diag.dtpartoprovavel else null end) as parto_previsto,
  (case when (paroco.cdreproducao = 7) then paroco.data else null end) as parto_real,
  tpar.descricao as tipo_parto,
  (select first 1 re.sexo from animal re where re.cdreproducao = paroco.cdreproducao) as sexo_com_cria,
  (case sp.cbasica when 6 then 'Novilha' when 7 then 'Vaca' else null end) as categoria,
  (case when (diag.diagnostico = 'P') then
        (case when ((paroco.diagnostico = 'N') or (paroco.cio in (1,2)) or (paroco.cdtiporeproducao in (1,2,3))) then 'Perdeu a gestao'
              when (paroco.cdtiporeproducao = 7) then null
              else 'Aberto' end
        ) else null end) as situacao,
   pes.nome as inseminador,
   se.nome as setor_na_tentativa, 
   (CASE spper.tipo 
   	WHEN 1 THEN 'Doadora' 
   	WHEN 2 THEN 'Receptora' 
   	WHEN 3 THEN 'Descarte' 
   	ELSE NULL END) AS classificacao  	
from
  reproducao rep
  join animal an on an.cdanimal = rep.cdanimal and an.cdcategoria in (6,7) and an.animalrebanho = 1
  left join reproducao par on par.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdtiporeproducao = 7 and re.cdanimal = an.cdanimal and re.data < rep.data order by re.data desc)
  join tiporeproducao tp on tp.cdtiporeproducao = rep.cdtiporeproducao
  left join animal tou on tou.cdanimal = rep.cdreprodutor
  left join animal emb on emb.cdanimal = rep.cdembriao
  left join animal maeemb on maeemb.cdanimal = emb.cdmae
  left join coleta col on col.cdcoleta = emb.cdcoleta
  left join reproducao diag on diag.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = rep.cdanimal and re.data > rep.data and
        ((re.cdtiporeproducao in (1,2,3,7)) or (re.cio in (1,2)) or (re.diagnostico is not null)) order by re.data asc)
  left join reproducao paroco on paroco.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = diag.cdanimal and re.data > diag.data and
        ((re.cdtiporeproducao in (1,2,3,7)) or (re.cio in (1,2)) or (re.diagnostico = 'N')) order by re.data asc)
 left join tipoparto tpar on tpar.cdtipoparto = paroco.cdtipoparto
 left join pessoa pes on pes.cdpessoa = rep.cdpessoa
 left join sp_categoriaanimal(rep.data, 'CDANIMAL = ' || rep.cdanimal) sp on sp.animal = rep.cdanimal
 left join sp_setoranimal(rep.cdanimal, rep.data) spse on 1 = 1 
 left join setor se on se.cdsetor = spse.setor
 left join SP_ANIMALPERIODOESPECIFICO(rep.CDANIMAL, rep.data) spper ON 1 = 1
where
  rep.cdtiporeproducao in (1,2,3)
  and (case when (rep.cdtiporeproducao in (1,2)) then rep.data
  	when rep.cdtiporeproducao = 3 then (rep.data - 7) else null end) between 
---INFORMAR O INCIO DO PERODO NO FORMATO AAAA-MM-DD
'2019-06-01' 
and
---INFORMAR O FINAL DO PERODO NO FORMATO AAAA-MM-DD
'2019-08-30'

